IS-IS Extensions for BIER-TE
Huaimo Chen
Futurewei
Boston, MA
USA
Huaimo.chen@futurewei.com
Mike McBride
Futurewei
michael.mcbride@futurewei.com
Aijun Wang
China Telecom
Beiqijia Town, Changping District
Beijing
102209
China
wangaj3@chinatelecom.cn
Gyan S. Mishra
Verizon Inc.
13101 Columbia Pike
Silver Spring
MD 20904
USA
301 502-1347
gyan.s.mishra@verizon.com
Yanhe Fan
Casa Systems
USA
yfan@casa-systems.com
Lei Liu
Fujitsu
USA
liulei.kddi@gmail.com
Xufeng Liu
IBM Corporation
USA
xufeng.liu.ietf@gmail.com
2022
This document describes IS-IS extensions for distributing BitPositions configured on the links in "Bit Index Explicit Replication Traffic Engineering" (BIER-TE) domain.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Introduction
[I-D.ietf-bier-te-arch] introduces Bit Index Explicit Replication (BIER) Traffic/Tree Engineering (BIER-TE). It is an architecture for per-packet stateless explicit point to multipoint (P2MP) multicast path/tree.
A link in a BIER-TE domain has its BitPositions. For a link between two nodes X and Y, there are two BitPositions for two forward connected adjacencies. These two adjacency BitPositions could be configured on nodes X and Y respectively. The BitPosition configured on X is the forward connected adjacency of Y. The BitPosition configured on Y is the forward connected adjacency of X.
This document proposes IS-IS extensions for distributing BitPositions configured on the links in "Bit Index Explicit Replication Traffic Engineering" (BIER-TE) domain.

Terminology
BIER: Bit Index Explicit Replication.
BIER-TE: BIER Traffic Engineering.
BFR: Bit-Forwarding Router.
BFIR: Bit-Forwarding Ingress Router.
BFER: Bit-Forwarding Egress Router.
BFR-id: BFR Identifier. It is a number in the range [1,65535].
BFR-NBR: BFR Neighbor.
IS-IS: Intermediate System to Intermediate System.

Extensions to IS-IS
This section describes protocol extensions to IS-IS for distributing BIER-TE information such as the BitPositions configured on the links in a BIER-TE domain.
An Extended IS Reachability TLV (Type 22) defined in [RFC5305] may contain Sub-TLVs (such as those for TE) that apply to a link/interface to a neighbor.
To encode multiple links or interfaces to neighbors, the structure inside TLV is repeated.
MT Intermediate Systems TLV (Type 222) defined in [RFC5120] may contain Sub-TLVs (such as those for TE) that apply to a link/interface. It is aligned with Extended IS Reachability TLV (Type 22) beside an additional two bytes in front at the beginning of the TLV for MT-ID.
BIER-TE Info Sub-TLV of the following format is defined and used in Extended IS Reachability TLV (Type 22) and/or MT Intermediate Systems TLV (Type 222) to advertise the BIER-TE information about a link or interface.

BIER-TE Info Sub-TLV

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |  Type (TBD1)  |    Length     | sub-domain-id |      BAR      |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |      IPA      |         BitPosition           |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |     DisEndBitPosition         |    Sub-Sub-TLVs (variable)    |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+                               +
   |                                                               ~
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
Type: TBD1 is to be assigned by IANA.
Length: Variable, dependent on Sub-Sub-TLVs.
sub-domain-id: Unique value identifying a BIER-TE sub-domain.
BAR: Single-octet BIER Algorithm used to calculate underlay paths to reach other BFRs. Values are allocated from the "BIER Algorithm" registry defined in [RFC8401].
IPA: Single-octet IGP Algorithm used to either modify, enhance, or replace the calculation of underlay paths to reach other BFRs as defined by the BAR value. Values are defined in the "IGP Algorithm Types" registry.
BitPosition: A 2-octet field encoding the BitPosition locally configured on the link/interface to an Intermediate System neighbor.
DisEndBitPosition: A 2-octet field encoding the BitPosition of the connection on the designated Intermediate Systems (Dis) end. This field is valid when the neighbor is a pseudonode. If the neighbor is not a pseudonode, this field MUST be ignored. The DisEndBitPosition may be configured on the link/interface to a transit network (i.e., broadcast link or say LAN).
No Sub-Sub-TLV is defined so far.

Security Considerations
TBD.

IANA Considerations
Under "IS-IS Sub-TLVs for TLVs Advertising Neighbor Information" registry, IANA is requested to assign a new Sub-TLV Type for BIER-TE Info as follows:

  +=======+=============+==+==+==+===+===+===+=============+
  | Type  |Description  |22|23|25|141|222|223|reference    |
  +=======+=============+==+==+==+===+===+===+=============+
  | TBD1  |BIER-TE Info |y |y |n | n | y | y |This document|
  +-------+-------------+--+--+--+---+---+---+-------------+

Acknowledgements
The authors would like to thank Les Ginsberg, Tony Przygienda and Acee Lindem for their comments on this work.

Normative References

Informative References
[RFC2119]
[RFC8174]
[I-D.ietf-bier-te-arch]
[RFC5305]
[RFC5120]
[RFC8401]